/**
  test_vacuumExtension.ctl contains all the code used for testing the vacuumExtension functionality
*/

#uses "vacuumExtension/vacuumExtension.ctl"
#uses "fwUnitTestComponentAsserts.ctl"
#uses "test/unVacuum/vacuumMocks.ctl"

const string UNVACUUM_TEST_DEVICE_NAME = "vacuum_test";
const string UNVACUUM_TEST_DEVICE_TYPE = "Vacuum_TestObject";

/**
  Tests the state dpe's dispatching and defaults values

  @covers vacuumExtension_StateMainColor  
*/
void test_vacuumExtension_StateDPEs(){
  dyn_string dsDpes = makeDynString();
 
  vacuumExtension_StateDPEs(UNVACUUM_TEST_DEVICE_NAME, dsDpes); 
  assertEqual(3, dynlen(dsDpes));

  assertFunctionCall(UNVACUUM_TEST_DEVICE_TYPE+"_StateDPEs");
}

/**
  Tests the state main state color dispatching

  @covers vacuumExtension_StateMainColor  
*/
void test_vacuumExtension_StateMainColorAndString(){  
  dyn_string dsDpes = makeDynString("frontend.alarm", "frontend.enabled", UNVACUUM_TEST_DEVICE_NAME+".ProcessInput.PosSt");  
  dyn_anytype daValues = makeDynAnytype(true, true, 1);
  string sColor, sState;
  vacuumExtension_StateMainColorAndString(UNVACUUM_TEST_DEVICE_NAME, dsDpes, daValues, sColor, sState);
  
  assertEqual("crap", sColor); 
  assertFunctionCall(UNVACUUM_TEST_DEVICE_TYPE+"_StateMainColorAndString");
}


/**
  Tests the state main color dispatching

  @covers vacuumExtension_StateMainColor  
*/
void test_vacuumExtension_StateErrorMessage(){  
  dyn_string dsDpes = makeDynString("frontend.alarm", "frontend.enabled", UNVACUUM_TEST_DEVICE_NAME+".ProcessInput.PosSt");  
  dyn_anytype daValues = makeDynAnytype(true, true, 1);
  string sMessage = vacuumExtension_StateErrorMessage(UNVACUUM_TEST_DEVICE_NAME, dsDpes, daValues);
  assertEqual("crap", sMessage);
  
  assertFunctionCall(UNVACUUM_TEST_DEVICE_TYPE+"_StateErrorMessage");
}

/**
  Tests the state main color dispatching

  @covers vacuumExtension_StateMainColor  
*/
void test_vacuumExtension_StateWarningMessage(){  
  dyn_string dsDpes = makeDynString("frontend.alarm", "frontend.enabled", UNVACUUM_TEST_DEVICE_NAME+".ProcessInput.PosSt");  
  dyn_anytype daValues = makeDynAnytype(true, true, 1);
  vacuumExtension_StateWarningMessage(UNVACUUM_TEST_DEVICE_NAME, dsDpes, daValues);
  
  assertFunctionCall(UNVACUUM_TEST_DEVICE_TYPE+"_StateWarningMessage");
}




