/**@file

// cpcVR_GTConfig.ctl
This library contains the import and export function of the CPC_VR_GT.

@par Creation Date
  24/05/2016

@par Constraints
  None

@par Usage
  Public

@par PVSS managers
  Ui, CTRL

@author
  Marcin Bes (BE-ICS)

@copyright
        &copy;Copyright CERN 2016 - all rights reserved
*/
//@{


// Constants
const string UN_CONFIG_CPC_VR_GT_DPT_NAME = "CPC_VR_GT";
const unsigned UN_CONFIG_CPC_VR_GT_LENGTH                   = 121;
//begin_TAG_SCRIPT_DEVICE_TYPE_constants

const unsigned UN_CONFIG_CPC_VR_GT_G1PRHST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRHST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_G1PRLST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRLST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_REL1HST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_REL2HST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_REL3HST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_REL4HST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_REL1LST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_REL2LST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_REL3LST_UNIT             = 1;
const unsigned UN_CONFIG_CPC_VR_GT_REL4LST_UNIT             = 1;

const unsigned UN_CONFIG_CPC_VR_GT_G1PRHST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRHST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_G1PRLST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRLST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_REL1HST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_REL2HST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_REL3HST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_REL4HST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_REL1LST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_REL2LST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_REL3LST_FORMAT           = 2;
const unsigned UN_CONFIG_CPC_VR_GT_REL4LST_FORMAT           = 2;

const unsigned UN_CONFIG_CPC_VR_GT_REL1TOFFMINST_UNIT       = 3;
const unsigned UN_CONFIG_CPC_VR_GT_REL2TOFFMINST_UNIT       = 3;
const unsigned UN_CONFIG_CPC_VR_GT_REL3TOFFMINST_UNIT       = 3;
const unsigned UN_CONFIG_CPC_VR_GT_REL4TOFFMINST_UNIT       = 3;

const unsigned UN_CONFIG_CPC_VR_GT_G1PRHST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRHST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_REL1HST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_REL2HST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_REL3HST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_REL4HST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_G1PRLST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRLST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_REL1LST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_REL2LST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_REL3LST_RANGEMAX         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_REL4LST_RANGEMAX         = 4;

const unsigned UN_CONFIG_CPC_VR_GT_G1PRHST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRHST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_REL1HST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_REL2HST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_REL3HST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_REL4HST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_G1PRLST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRLST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_REL1LST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_REL2LST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_REL3LST_RANGEMIN         = 5;
const unsigned UN_CONFIG_CPC_VR_GT_REL4LST_RANGEMIN         = 5;

const unsigned UN_CONFIG_CPC_VR_GT_REL1TOFFMINST_RANGEMAX   = 6;
const unsigned UN_CONFIG_CPC_VR_GT_REL2TOFFMINST_RANGEMAX   = 6;
const unsigned UN_CONFIG_CPC_VR_GT_REL3TOFFMINST_RANGEMAX   = 6;
const unsigned UN_CONFIG_CPC_VR_GT_REL4TOFFMINST_RANGEMAX   = 6;

const unsigned UN_CONFIG_CPC_VR_GT_REL1TOFFMINST_RANGEMIN   = 7;
const unsigned UN_CONFIG_CPC_VR_GT_REL2TOFFMINST_RANGEMIN   = 7;
const unsigned UN_CONFIG_CPC_VR_GT_REL3TOFFMINST_RANGEMIN   = 7;
const unsigned UN_CONFIG_CPC_VR_GT_REL4TOFFMINST_RANGEMIN   = 7;

const unsigned UN_CONFIG_CPC_VR_GT_DEADBAND                 = 8;
const unsigned UN_CONFIG_CPC_VR_GT_DEADBAND_TYPE            = 9;
const unsigned UN_CONFIG_CPC_VR_GT_ARCHIVE_ACTIVE           = 10;
const unsigned UN_CONFIG_CPC_VR_GT_ARCHIVE_TIME_FILTER      = 11;

const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_STSREG01         = 12;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_EVSTSREG01       = 13;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_OBJECTST         = 14;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_COMMST           = 15;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_HWCONFIGST       = 16;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_FIRMVERSST       = 17;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL1ST           = 18; 
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL2ST           = 19;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL3ST           = 20;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL4ST           = 21;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_PRG1ST           = 22;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_PRG3ST           = 23;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G1TFILTST        = 24;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G2TFILTST        = 25;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G3TFILTST        = 26;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G4TFILTST        = 27;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G1PRSOURST       = 28;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G3PRSOURST       = 29;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G1HWVARST        = 30;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G2HWVARST        = 31;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G3HWVARST        = 32;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G4HWVARST        = 33;
//const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_AOTYPEST         = 40;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL1SCRST        = 34;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL2SCRST        = 35;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL3SCRST        = 36;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL4SCRST        = 37;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G1PRHST          = 38;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G3PRHST          = 39;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL1HST          = 40;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL2HST          = 41;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL3HST          = 42;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL4HST          = 43;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G1PRLST          = 44;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G3PRLST          = 45;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL1LST          = 46;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL2LST          = 47;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL3LST          = 48;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL4LST          = 49;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_GPENNLCOST       = 50;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL1TOFFMINST    = 51;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL2TOFFMINST    = 52;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL3TOFFMINST    = 53;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_REL4TOFFMINST    = 54;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G1PENNLEAKST     = 62;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G3PENNLEAKST     = 63;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G2ATMCALST       = 64;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G2HVACCALST      = 65;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G4ATMCALST       = 66;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G4HVACCALST      = 67;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G1GASCORRST      = 68;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G2GASCORRST      = 69;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G3GASCORRST      = 70;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_G4GASCORRST      = 71;

const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MANREG01         = 55;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MANREG02         = 56;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MANREG03         = 57;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG1TFILTR        = 58;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG2TFILTR        = 59;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG3TFILTR        = 60;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG4TFILTR        = 61;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG1PRSOURR       = 62;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG3PRSOURR       = 63;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL1SCRR        = 64;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL2SCRR        = 65;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL3SCRR        = 66;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL4SCRR        = 67;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG1PRHR          = 68;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG3PRHR          = 69;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL1HR          = 70;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL2HR          = 71;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL3HR          = 72;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL4HR          = 73;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG1PRLR          = 74;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG3PRLR          = 75;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL1LR          = 76;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL2LR          = 77;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL3LR          = 78;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL4LR          = 79;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MGPENNLCOR       = 80;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL1TOFFMINR    = 81;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL2TOFFMINR    = 82;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL3TOFFMINR    = 83;
const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MREL4TOFFMINR    = 84;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG1PENNLEAKR     = 82;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG3PENNLEAKR     = 103;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG2ATMCALR       = 104;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG2HVACCALR      = 105;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG4ATMCALR       = 106;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG4HVACCALR      = 107;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG1GASCORRR      = 108;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG2GASCORRR      = 109;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG3GASCORRR      = 110;
// const unsigned UN_CONFIG_CPC_VR_GT_ADDRESS_MG4GASCORRR      = 111;

const unsigned UN_CONFIG_CPC_VR_GT_DG1TFILT_DEFAUTL         = 85;
const unsigned UN_CONFIG_CPC_VR_GT_DG2TFILT_DEFAUTL         = 86;
const unsigned UN_CONFIG_CPC_VR_GT_DG3TFILT_DEFAUTL         = 87;
const unsigned UN_CONFIG_CPC_VR_GT_DG4TFILT_DEFAUTL         = 88;
const unsigned UN_CONFIG_CPC_VR_GT_DG1PRSOUR_DEFAUTL        = 89;
const unsigned UN_CONFIG_CPC_VR_GT_DG3PRSOUR_DEFAUTL        = 90;
const unsigned UN_CONFIG_CPC_VR_GT_DREL1SCR_DEFAUTL         = 91;
const unsigned UN_CONFIG_CPC_VR_GT_DREL2SCR_DEFAUTL         = 92;
const unsigned UN_CONFIG_CPC_VR_GT_DREL3SCR_DEFAUTL         = 93;
const unsigned UN_CONFIG_CPC_VR_GT_DREL4SCR_DEFAUTL         = 94;
const unsigned UN_CONFIG_CPC_VR_GT_DG1PRH_DEFAUTL           = 95;
const unsigned UN_CONFIG_CPC_VR_GT_DG3PRH_DEFAUTL           = 96;
const unsigned UN_CONFIG_CPC_VR_GT_DREL1H_DEFAUTL           = 97;
const unsigned UN_CONFIG_CPC_VR_GT_DREL2H_DEFAUTL           = 98;
const unsigned UN_CONFIG_CPC_VR_GT_DREL3H_DEFAUTL           = 99;
const unsigned UN_CONFIG_CPC_VR_GT_DREL4H_DEFAUTL           = 100;
const unsigned UN_CONFIG_CPC_VR_GT_DG1PRL_DEFAUTL           = 101;
const unsigned UN_CONFIG_CPC_VR_GT_DG3PRL_DEFAUTL           = 102;
const unsigned UN_CONFIG_CPC_VR_GT_DREL1L_DEFAUTL           = 103;
const unsigned UN_CONFIG_CPC_VR_GT_DREL2L_DEFAUTL           = 104;
const unsigned UN_CONFIG_CPC_VR_GT_DREL3L_DEFAUTL           = 105;
const unsigned UN_CONFIG_CPC_VR_GT_DREL4L_DEFAUTL           = 106;
const unsigned UN_CONFIG_CPC_VR_GT_DGPENNLCO_DEFAUTL        = 107;
const unsigned UN_CONFIG_CPC_VR_GT_DREL1TOFFMIN_DEFAUTL     = 108;
const unsigned UN_CONFIG_CPC_VR_GT_DREL2TOFFMIN_DEFAUTL     = 109;
const unsigned UN_CONFIG_CPC_VR_GT_DREL3TOFFMIN_DEFAUTL     = 110;
const unsigned UN_CONFIG_CPC_VR_GT_DREL4TOFFMIN_DEFAUTL     = 111;
//const unsigned UN_CONFIG_CPC_VR_GT_DG1PENNLEAK_DEFAUTL      = 139;
//const unsigned UN_CONFIG_CPC_VR_GT_DG3PENNLEAK_DEFAUTL      = 140;
//const unsigned UN_CONFIG_CPC_VR_GT_DG2ATMCAL_DEFAUTL        = 141;
//const unsigned UN_CONFIG_CPC_VR_GT_DG2HVACCAL_DEFAUTL       = 142;
//const unsigned UN_CONFIG_CPC_VR_GT_DG4ATMCAL_DEFAUTL        = 143;
//const unsigned UN_CONFIG_CPC_VR_GT_DG4HVACCAL_DEFAUTL       = 144;
//const unsigned UN_CONFIG_CPC_VR_GT_DG1GASCORR_DEFAUTL       = 145;
//const unsigned UN_CONFIG_CPC_VR_GT_DG2GASCORR_DEFAUTL       = 146;
//const unsigned UN_CONFIG_CPC_VR_GT_DG3GASCORR_DEFAUTL       = 147;
//const unsigned UN_CONFIG_CPC_VR_GT_DG4GASCORR_DEFAUTL       = 148;

const unsigned UN_CONFIG_CPC_VR_GT_OBJECTST_MAPPING         = 112;
const unsigned UN_CONFIG_CPC_VR_GT_COMMST_MAPPING           = 113;

const unsigned UN_CONFIG_CPC_VR_GT_REL1ST_MAPPING           = 114;
const unsigned UN_CONFIG_CPC_VR_GT_REL2ST_MAPPING           = 114;
const unsigned UN_CONFIG_CPC_VR_GT_REL3ST_MAPPING           = 114;
const unsigned UN_CONFIG_CPC_VR_GT_REL4ST_MAPPING           = 114;
const unsigned UN_CONFIG_CPC_VR_GT_PRG1ST_MAPPING           = 114;
const unsigned UN_CONFIG_CPC_VR_GT_PRG3ST_MAPPING           = 114;

const unsigned UN_CONFIG_CPC_VR_GT_G1TFILTST_MAPPING        = 115;
const unsigned UN_CONFIG_CPC_VR_GT_G2TFILTST_MAPPING        = 115;
const unsigned UN_CONFIG_CPC_VR_GT_G3TFILTST_MAPPING        = 115;
const unsigned UN_CONFIG_CPC_VR_GT_G4TFILTST_MAPPING        = 115;

const unsigned UN_CONFIG_CPC_VR_GT_G1PRSOURST_MAPPING       = 116;
const unsigned UN_CONFIG_CPC_VR_GT_G3PRSOURST_MAPPING       = 116;
const unsigned UN_CONFIG_CPC_VR_GT_REL1SCRST_MAPPING        = 116;
const unsigned UN_CONFIG_CPC_VR_GT_REL2SCRST_MAPPING        = 116;
const unsigned UN_CONFIG_CPC_VR_GT_REL3SCRST_MAPPING        = 116;
const unsigned UN_CONFIG_CPC_VR_GT_REL4SCRST_MAPPING        = 116;

const unsigned UN_CONFIG_CPC_VR_GT_GPENNLCOST_MAPPING       = 117;
//const unsigned UN_CONFIG_CPC_VR_GT_AOTYPEST_MAPPING         = 155;

const unsigned UN_CONFIG_CPC_VR_GT_G1HWVARST_UNIT           = 118;
const unsigned UN_CONFIG_CPC_VR_GT_G2HWVARST_UNIT           = 119;
const unsigned UN_CONFIG_CPC_VR_GT_G3HWVARST_UNIT           = 120;
const unsigned UN_CONFIG_CPC_VR_GT_G4HWVARST_UNIT           = 121;

const unsigned UN_CONFIG_CPC_VR_GT_ADDITIONAL_LENGTH          = 7;

const unsigned UN_CONFIG_CPC_VR_GT_ADDITIONAL_MASKEVENT       = 1;
const unsigned UN_CONFIG_CPC_VR_GT_ADDITIONAL_PARAMETERS      = 2;
const unsigned UN_CONFIG_CPC_VR_GT_ADDITIONAL_MASTER_NAME     = 3;
const unsigned UN_CONFIG_CPC_VR_GT_ADDITIONAL_PARENTS         = 4;
const unsigned UN_CONFIG_CPC_VR_GT_ADDITIONAL_CHILDREN        = 5;
const unsigned UN_CONFIG_CPC_VR_GT_ADDITIONAL_TYPE            = 6;
const unsigned UN_CONFIG_CPC_VR_GT_ADDITIONAL_SECOND_ALIAS    = 7;

//end_TAG_SCRIPT_DEVICE_TYPE_constants

/**
DPE configuration
TODO: use fw info instead
*/
mapping CPC_VR_GTConfig_getConfig() {
    mapping config;
    mapping props;

//begin_TAG_SCRIPT_DEVICE_TYPE_deviceConfig
//
mappingClear(props);
props["address"]        = ".ProcessInput.StsReg01";
props["dataType"]       = CPC_UINT16;
config["StsReg01"]      = props;

//
mappingClear(props);
props["hasArchive"]     = true;
props["address"]        = ".ProcessInput.evStsReg01";
props["dataType"]       = CPC_INT32;
config["evStsReg01"]    = props;

// 
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.ObjectSt";
props["dataType"]       = CPC_UINT16;
config["ObjectSt"]      = props;

//
mappingClear(props);
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.CommSt";
props["dataType"]       = CPC_UINT16;
config["CommSt"]        = props;

// Controller HW Configuration
mappingClear(props);
props["hasArchive"]     = true;
props["address"]        = ".ProcessInput.HWConfigSt";
props["dataType"]       = CPC_UINT16;
config["HWConfigSt"]    = props;

// Firmware version
mappingClear(props);
props["hasArchive"]     = true;
props["address"]        = ".ProcessInput.FirmVersSt";
props["dataType"]       = CPC_UINT16;
config["FirmVersSt"]    = props;

// Relay 1 Status
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.Rel1St";
props["dataType"]       = CPC_UINT16;
config["Rel1St"]        = props;

// Relay 2 Status
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.Rel2St";
props["dataType"]       = CPC_UINT16;
config["Rel2St"]        = props;

// Relay 3 Status
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.Rel3St";
props["dataType"]       = CPC_UINT16;
config["Rel3St"]        = props;

// Relay 4 Status
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.Rel4St";
props["dataType"]       = CPC_UINT16;
config["Rel4St"]        = props;

// Protect Gauge1 status
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.PrG1St";
props["dataType"]       = CPC_UINT16;
config["PrG1St"]        = props;

// Protect Gauge3 status
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.PrG3St";
props["dataType"]       = CPC_UINT16;
config["PrG3St"]        = props;

// Gauge1 Filter time Index
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.G1TFiltSt";
props["dataType"]       = CPC_UINT16;
config["G1TFiltSt"]     = props;

// Gauge2 Filter time Index
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.G2TFiltSt";
props["dataType"]       = CPC_UINT16;
config["G2TFiltSt"]     = props;

// Gauge3 Filter time Index
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.G3TFiltSt";
props["dataType"]       = CPC_UINT16;
config["G3TFiltSt"]     = props;

// Gauge4 Filter time Index
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.G4TFiltSt";
props["dataType"]       = CPC_UINT16;
config["G4TFiltSt"]     = props;

// Gauge1 Protect Source
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.G1PrSourSt";
props["dataType"]       = CPC_UINT16;
config["G1PrSourSt"]    = props;

// Gauge3 Protect Source
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.G3PrSourSt";
props["dataType"]       = CPC_UINT16;
config["G3PrSourSt"]    = props;

// Gauge1 HW physical variable
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.G1HWVarSt";
props["dataType"]       = CPC_FLOAT;
config["G1HWVarSt"]     = props;

// Gauge2 HW physical variable
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.G2HWVarSt";
props["dataType"]       = CPC_FLOAT;
config["G2HWVarSt"]     = props;

// Gauge3 HW physical variable
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.G3HWVarSt";
props["dataType"]       = CPC_FLOAT;
config["G3HWVarSt"]     = props;

// Gauge4 HW physical variable
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.G4HWVarSt";
props["dataType"]       = CPC_FLOAT;
config["G4HWVarSt"]     = props;

// Analog Output type 
//mappingClear(props);
//props["hasArchive"]     = true;
//props["hasMapping"]     = true;
//props["address"]        = ".ProcessInput.AOTypeSt";
//props["dataType"]       = CPC_UINT16;
//config["AOTypeSt"]      = props;

// Relay1 Source
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.Rel1ScrSt";
props["dataType"]       = CPC_UINT16;
config["Rel1ScrSt"]     = props;

// Relay2 Source
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.Rel2ScrSt";
props["dataType"]       = CPC_UINT16;
config["Rel2ScrSt"]     = props;

// Relay3 Source
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.Rel3ScrSt";
props["dataType"]       = CPC_UINT16;
config["Rel3ScrSt"]     = props;

// Relay4 Source
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["address"]        = ".ProcessInput.Rel4ScrSt";
props["dataType"]       = CPC_UINT16;
config["Rel4ScrSt"]     = props;

// Gauge1 Protect High Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.G1PrHSt";
props["dataType"]       = CPC_FLOAT;
config["G1PrHSt"]       = props;

// Gauge3 Protect High Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.G3PrHSt";
props["dataType"]       = CPC_FLOAT;
config["G3PrHSt"]       = props;

// Relay1 High Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.Rel1HSt";
props["dataType"]       = CPC_FLOAT;
config["Rel1HSt"]       = props;

// Relay2 High Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.Rel2HSt";
props["dataType"]       = CPC_FLOAT;
config["Rel2HSt"]       = props;

// Relay3 High Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.Rel3HSt";
props["dataType"]       = CPC_FLOAT;
config["Rel3HSt"]       = props;

// Relay4 High Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.Rel4HSt";
props["dataType"]       = CPC_FLOAT;
config["Rel4HSt"]       = props;

// Gauge1 Protect Low Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.G1PrLSt";
props["dataType"]       = CPC_FLOAT;
config["G1PrLSt"]       = props;

// Gauge3 Protect Low Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.G3PrLSt";
props["dataType"]       = CPC_FLOAT;
config["G3PrLSt"]       = props;

// Relay1 Low Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.Rel1LSt";
props["dataType"]       = CPC_FLOAT;
config["Rel1LSt"]       = props;

// Relay2 Low Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.Rel2LSt";
props["dataType"]       = CPC_FLOAT;
config["Rel2LSt"]       = props;

// Relay3 Low Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.Rel3LSt";
props["dataType"]       = CPC_FLOAT;
config["Rel3LSt"]       = props;

// Relay4 Low Threshold
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasPvRange"]     = true;
props["hasFormat"]      = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.Rel4LSt";
props["dataType"]       = CPC_FLOAT;
config["Rel4LSt"]       = props;

// Penning Gauges Under Range control
mappingClear(props);
props["hasArchive"]     = true;
props["hasMapping"]     = true;
props["hasSmooth"]      = true;
props["address"]        = ".ProcessInput.GPennLCoSt";
props["dataType"]       = CPC_UINT16;
config["GPennLCoSt"]   = props;

// Relay1 Timer Min. ON
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasSmooth"]      = true;
props["hasPvRange"]     = true;
props["address"]        = ".ProcessInput.Rel1ToffMinSt";
props["dataType"]       = CPC_FLOAT;
config["Rel1ToffMinSt"] = props;

// Relay2 Timer Min. ON
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasSmooth"]      = true;
props["hasPvRange"]     = true;
props["address"]        = ".ProcessInput.Rel2ToffMinSt";
props["dataType"]       = CPC_FLOAT;
config["Rel2ToffMinSt"] = props;

// Relay3 Timer Min. ON
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasSmooth"]      = true;
props["hasPvRange"]     = true;
props["address"]        = ".ProcessInput.Rel3ToffMinSt";
props["dataType"]       = CPC_FLOAT;
config["Rel3ToffMinSt"] = props;

// Relay4 Timer Min. ON
mappingClear(props);
props["hasArchive"]     = true;
props["hasUnit"]        = true;
props["hasSmooth"]      = true;
props["hasPvRange"]     = true;
props["address"]        = ".ProcessInput.Rel4ToffMinSt";
props["dataType"]       = CPC_FLOAT;
config["Rel4ToffMinSt"] = props;

// Gauge1 Penning Cable Leakage Current Software compensation
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G1PennLeakSt";
// props["dataType"]       = CPC_FLOAT;
// config["G1PennLeakSt"]  = props;

// // Gauge3 Penning Cable Leakage Current Software compensation
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G3PennLeakSt";
// props["dataType"]       = CPC_FLOAT;
// config["G3PennLeakSt"]  = props;

// Gauge2 ATM Calibration
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G2ATMCalSt";
// props["dataType"]       = CPC_FLOAT;
// config["G2ATMCalSt"]    = props;

// Gauge2 HIGH VAC Calibration
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G2HVacCalSt";
// props["dataType"]       = CPC_FLOAT;
// config["G2HVacCalSt"]   = props;

// Gauge2 ATM Calibration
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G4ATMCalSt";
// props["dataType"]       = CPC_FLOAT;
// config["G4ATMCalSt"]    = props;

// Gauge4 HIGH VAC Calibration
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G4HVacCalSt";
// props["dataType"]       = CPC_FLOAT;
// config["G4HVacCalSt"]   = props;

// Gauge1 Gas Correction
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G1GasCorrSt";
// props["dataType"]       = CPC_FLOAT;
// config["G1GasCorrSt"]   = props;

// Gauge2 Gas Correction
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G2GasCorrSt";
// props["dataType"]       = CPC_FLOAT;
// config["G2GasCorrSt"]   = props;

// Gauge3 Gas Correction
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G3GasCorrSt";
// props["dataType"]       = CPC_FLOAT;
// config["G3GasCorrSt"]   = props;

// // Gauge4 Gas Correction
// mappingClear(props);
// props["hasArchive"]     = true;
// props["hasSmooth"]      = true;
// props["address"]        = ".ProcessInput.G4GasCorrSt";
// props["dataType"]       = CPC_FLOAT;
// config["G4GasCorrSt"]   = props;

//
mappingClear(props);
props["address"]        = ".ProcessOutput.ManReg01";
props["dataType"]       = CPC_UINT16;
config["ManReg01"]      = props;

//
mappingClear(props);
props["address"]        = ".ProcessOutput.ManReg02";
props["dataType"]       = CPC_UINT16;
config["ManReg02"]      = props;

//
mappingClear(props);
props["address"]        = ".ProcessOutput.ManReg03";
props["dataType"]       = CPC_UINT16;
config["ManReg03"]      = props;

// Gauge1 Filter time Index
mappingClear(props);
props["address"]        = ".ProcessOutput.MG1TFiltR";
props["dataType"]       = CPC_UINT16;
config["MG1TFiltR"]     = props;

// Gauge2 Filter time Index
mappingClear(props);
props["address"]        = ".ProcessOutput.MG2TFiltR";
props["dataType"]       = CPC_UINT16;
config["MG2TFiltR"]     = props;

// Gauge3 Filter time Index
mappingClear(props);
props["address"]        = ".ProcessOutput.MG3TFiltR";
props["dataType"]       = CPC_UINT16;
config["MG3TFiltR"]     = props;

// Gauge4 Filter time Index
mappingClear(props);
props["address"]        = ".ProcessOutput.MG4TFiltR";
props["dataType"]       = CPC_UINT16;
config["MG4TFiltR"]     = props;

// Gauge1 Protect Source
mappingClear(props);
props["address"]        = ".ProcessOutput.MG1PrSourR";
props["dataType"]       = CPC_UINT16;
config["MG1PrSourR"]    = props;

// Gauge3 Protect Source
mappingClear(props);
props["address"]        = ".ProcessOutput.MG3PrSourR";
props["dataType"]       = CPC_UINT16;
config["MG3PrSourR"]    = props;

// Relay1 Source
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel1ScrR";
props["dataType"]       = CPC_UINT16;
config["MRel1ScrR"]     = props;

// Relay2 Source
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel2ScrR";
props["dataType"]       = CPC_UINT16;
config["MRel2ScrR"]     = props;

// Relay3 Source
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel3ScrR";
props["dataType"]       = CPC_UINT16;
config["MRel3ScrR"]     = props;

// Relay4 Source
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel4ScrR";
props["dataType"]       = CPC_UINT16;
config["MRel4ScrR"]     = props;

// Gauge1 Protect High Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MG1PrHR";
props["dataType"]       = CPC_FLOAT;
config["MG1PrHR"]       = props;

// Gauge3 Protect High Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MG3PrHR";
props["dataType"]       = CPC_FLOAT;
config["MG3PrHR"]       = props;

// Relay1 High Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel1HR";
props["dataType"]       = CPC_FLOAT;
config["MRel1HR"]       = props;

// Relay2 High Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel2HR";
props["dataType"]       = CPC_FLOAT;
config["MRel2HR"]       = props;

// Relay3 High Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel3HR";
props["dataType"]       = CPC_FLOAT;
config["MRel3HR"]       = props;

// Relay4 High Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel4HR";
props["dataType"]       = CPC_FLOAT;
config["MRel4HR"]       = props;

// Gauge1 Protect Low Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MG1PrLR";
props["dataType"]       = CPC_FLOAT;
config["MG1PrLR"]       = props;

// Gauge3 Protect Low Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MG3PrLR";
props["dataType"]       = CPC_FLOAT;
config["MG3PrLR"]       = props;

// Relay1 Low Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel1LR";
props["dataType"]       = CPC_FLOAT;
config["MRel1LR"]       = props;

// Relay2 Low Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel2LR";
props["dataType"]       = CPC_FLOAT;
config["MRel2LR"]       = props;

// Relay3 Low Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel3LR";
props["dataType"]       = CPC_FLOAT;
config["MRel3LR"]       = props;

// Relay4 Low Threshold
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel4LR";
props["dataType"]       = CPC_FLOAT;
config["MRel4LR"]       = props;

// Penning Gauge1 Under Range control
mappingClear(props);
props["address"]        = ".ProcessOutput.MGPennLCoR";
props["dataType"]       = CPC_UINT16;
config["MGPennLCoR"]    = props;

// Relay1 Timer Min. ON
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel1ToffMinR";
props["dataType"]       = CPC_FLOAT;
config["MRel1ToffMinR"] = props;

// Relay2 Timer Min. ON
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel2ToffMinR";
props["dataType"]       = CPC_FLOAT;
config["MRel2ToffMinR"] = props;

// Relay3 Timer Min. ON
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel3ToffMinR";
props["dataType"]       = CPC_FLOAT;
config["MRel3ToffMinR"] = props;

// Relay4 Timer Min. ON
mappingClear(props);
props["address"]        = ".ProcessOutput.MRel4ToffMinR";
props["dataType"]       = CPC_FLOAT;
config["MRel4ToffMinR"] = props;

// Gauge1 Penning Cable Leakage Current Software compensation
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG1PennLeakR";
// props["dataType"]       = CPC_FLOAT;
// config["MG1PennLeakR"]  = props;

// // Gauge3 Penning Cable Leakage Current Software compensation
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG3PennLeakR";
// props["dataType"]       = CPC_FLOAT;
// config["MG3PennLeakR"]  = props;

// Gauge2 ATM Calibration
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG2ATMCalR";
// props["dataType"]       = CPC_FLOAT;
// config["MG2ATMCalR"]    = props;

// Gauge2 HIGH VAC Calibration
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG2HVacCalR";
// props["dataType"]       = CPC_FLOAT;
// config["MG2HVacCalR"]   = props;

// // Gauge4 ATM Calibration
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG4ATMCalR";
// props["dataType"]       = CPC_FLOAT;
// config["MG4ATMCalR"]    = props;

// // Gauge4 HIGH VAC Calibration
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG4HVacCalR";
// props["dataType"]       = CPC_FLOAT;
// config["MG4HVacCalR"]   = props;

// // Gauge1 Gas Correction
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG1GasCorrR";
// props["dataType"]       = CPC_FLOAT;
// config["MG1GasCorrR"]   = props;

// // Gauge2 Gas Correction
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG2GasCorrR";
// props["dataType"]       = CPC_FLOAT;
// config["MG2GasCorrR"]   = props;

// // Gauge3 Gas Correction
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG3GasCorrR";
// props["dataType"]       = CPC_FLOAT;
// config["MG3GasCorrR"]   = props;

// // Gauge4 Gas Correction
// mappingClear(props);
// props["address"]        = ".ProcessOutput.MG4GasCorrR";
// props["dataType"]       = CPC_FLOAT;
// config["MG4GasCorrR"]   = props;

//end_TAG_SCRIPT_DEVICE_TYPE_deviceConfig

    return config;
}

/**
Returns the list of parameter names that passed via config line.
*/
dyn_string CPC_VR_GTConfig_getParamNames() {
//begin_TAG_SCRIPT_DEVICE_TYPE_getParamNames
    return makeDynString(CPC_PARAMS_GAUGE1_NAME, CPC_PARAMS_GAUGE2_NAME, CPC_PARAMS_GAUGE3_NAME, CPC_PARAMS_GAUGE4_NAME,
                         CPC_PARAMS_RELAY1_NAME, CPC_PARAMS_RELAY2_NAME, CPC_PARAMS_RELAY3_NAME, CPC_PARAMS_RELAY4_NAME
    );
//end_TAG_SCRIPT_DEVICE_TYPE_getParamNames
}

/** Check custom configuration
*/
CPC_VR_GTConfig_checkCustomConfig(dyn_string configLine, bool hasArchive, dyn_string &exceptionInfo) {
//begin_TAG_SCRIPT_DEVICE_TYPE_checkCustomConfig
    
    int iValue, iMax, iMin;
    int fValue, fMax, fMin;

    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1TFILT_DEFAUTL], iValue, exceptionInfo);
    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG2TFILT_DEFAUTL], iValue, exceptionInfo);    
    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3TFILT_DEFAUTL], iValue, exceptionInfo);
    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG4TFILT_DEFAUTL], iValue, exceptionInfo);

    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1PRSOUR_DEFAUTL], iValue, exceptionInfo);
    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3PRSOUR_DEFAUTL], iValue, exceptionInfo);
    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL1SCR_DEFAUTL], iValue, exceptionInfo);
    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL2SCR_DEFAUTL], iValue, exceptionInfo);
    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL3SCR_DEFAUTL], iValue, exceptionInfo);
    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL4SCR_DEFAUTL], iValue, exceptionInfo);
    

    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_G1PRHST_RANGEMIN], fMin, exceptionInfo);
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_G1PRHST_RANGEMAX], fMax, exceptionInfo);

    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1PRH_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DG1PRH_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3PRH_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DG3PRH_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL1H_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DREL1H_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL2H_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DREL2H_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL3H_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DREL3H_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL4H_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DREL4H_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1PRL_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DG1PRL_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3PRL_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DG3PRL_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL1L_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DREL1L_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL2L_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DREL2L_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL3L_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DREL3L_DEFAUTL " + getCatStr("unCPCGeneration", "BADRANGE"), ""); }
    unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL4L_DEFAUTL], fValue, exceptionInfo);
    if ((fValue < fMin) || (fValue > fMax)) { fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogParameterConfig_checkCommonConfig: UN_CONFIG_CPC_VR_GT_DREL4L_DEFAUTL" + getCatStr("unCPCGeneration", "BADRANGE"), ""); }

    unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DGPENNLCO_DEFAUTL], iValue, exceptionInfo);

    // not communicated
    
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL1TOFFMIN_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL2TOFFMIN_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL3TOFFMIN_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL4TOFFMIN_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1PENNLEAK_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3PENNLEAK_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG2ATMCAL_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG2HVACCAL_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG4ATMCAL_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG4HVACCAL_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1GASCORR_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG2GASCORR_DEFAUTL], fValue, exceptionInfo);
    //unCnfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3GASCORR_DEFAUTL], fValue, exceptionInfo);
    //unConfigGenericFunctions_checkFloat(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG4GASCORR_DEFAUTL], fValue, exceptionInfo);
    
//end_TAG_SCRIPT_DEVICE_TYPE_checkCustomConfig
}

/** Set custom configuration
*/
CPC_VR_GTConfig_setCustomConfig(dyn_string dsConfigs, bool hasArchive, dyn_string &exceptionInfo) {
//begin_TAG_SCRIPT_DEVICE_TYPE_setCustomConfig

dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG1TFilt", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1TFILT_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG2TFilt", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG2TFILT_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG3TFilt", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3TFILT_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG4TFilt", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG4TFILT_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG1PrSour", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1PRSOUR_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG3PrSour", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3PRSOUR_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel1Scr", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL1SCR_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel2Scr", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL2SCR_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel3Scr", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL3SCR_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel4Scr", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL4SCR_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG1PrH", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1PRH_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG3PrH", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3PRH_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel1H", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL1H_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel2H", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL2H_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel3H", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL3H_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel4H", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL4H_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG1PrL", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1PRL_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG3PrL", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3PRL_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel1L", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL1L_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel2L", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL2L_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel3L", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL3L_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel4L", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL4L_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DGPennLCo", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DGPENNLCO_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel1ToffMin", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL1TOFFMIN_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel2ToffMin", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL2TOFFMIN_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel3ToffMin", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL3TOFFMIN_DEFAUTL]);
dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DRel4ToffMin", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DREL4TOFFMIN_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG1PennLeak", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1PENNLEAK_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG3PennLeak", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3PENNLEAK_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG2ATMCal", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG2ATMCAL_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG2HVacCal", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG2HVACCAL_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG4ATMCal", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG4ATMCAL_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG4HVacCal", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG4HVACCAL_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG1GasCorr", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG1GASCORR_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG2GasCorr", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG2GASCORR_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG3GasCorr", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG3GASCORR_DEFAUTL]);
//dpSetWait(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessOutput.DG4GasCorr", dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_VR_GT_DG4GASCORR_DEFAUTL]);



//end_TAG_SCRIPT_DEVICE_TYPE_setCustomConfig

}

/**
Purpose: Export CPC_VR_GT Devices

Usage: External function

PVSS manager usage: NG, NV
*/
CPC_VR_GTConfig_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    string sObject = UN_CONFIG_CPC_VR_GT_DPT_NAME;
    int amount = dynlen(dsDpList);
    for (int i = 1; i <= amount; i++) {
        dyn_string dsDpParameters;
        string currentDP = dsDpList[i];

        if (!dpExists(currentDP)) { continue; }

        unExportDevice_getAllCommonParameters(currentDP, sObject, dsDpParameters);
        //begin_TAG_SCRIPT_DEVICE_TYPE_export

        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.G1PrHSt");
        cpcExportGenericFunctions_getFormat(currentDP, dsDpParameters, ".ProcessInput.G1PrHSt");
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.Rel1ToffMinSt");
        cpcExportGenericFunctions_getRange(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.G1PrHSt");
        cpcExportGenericFunctions_getRange(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.Rel1ToffMinSt");
        cpcExportGenericFunctions_getDeadband(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.G1HWVarSt");
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters, ".ProcessInput.Rel1St");
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "StsReg01",        true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "evStsReg01",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ObjectSt",        true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "CommSt",          true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "HWConfigSt",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "FirmVersSt",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel1St",          true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel2St",          true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel3St",          true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel4St",          true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "PrG1St",          true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "PrG3St",          true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G1TFiltSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G2TFiltSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G3TFiltSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G4TFiltSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G1PrSourSt",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G3PrSourSt",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G1HWVarSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G2HWVarSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G3HWVarSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G4HWVarSt",       true, dsDpParameters);
        //cpcExportGenericFunctions_processAddress(currentDP, sObject, "AOTypeSt",        true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel1ScrSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel2ScrSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel3ScrSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel4ScrSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G1PrHSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G3PrHSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel1HSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel2HSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel3HSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel4HSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G1PrLSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "G3PrLSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel1LSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel2LSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel3LSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel4LSt",         true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "GPennLCoSt",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel1ToffMinSt",   true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel2ToffMinSt",   true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel3ToffMinSt",   true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "Rel4ToffMinSt",   true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G1PennLeakSt",    true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G3PennLeakSt",    true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G2ATMCalSt",      true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G2HVacCalSt",     true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G4ATMCalSt",      true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G4HVacCalSt",     true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G1GasCorrSt",     true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G2GasCorrSt",     true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G3GasCorrSt",     true, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "G4GasCorrSt",     true, dsDpParameters);

        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ManReg01",        false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ManReg02",        false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ManReg03",        false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG1TFiltR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG2TFiltR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG3TFiltR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG4TFiltR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG1PrSourR",      false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG3PrSourR",      false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel1ScrR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel2ScrR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel3ScrR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel4ScrR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG1PrHR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG3PrHR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel1HR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel2HR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel3HR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel4HR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG1PrLR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG3PrLR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel1LR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel2LR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel3LR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel4LR",         false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MGPennLCoR",      false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel1ToffMinR",   false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel2ToffMinR",   false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel3ToffMinR",   false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MRel4ToffMinR",   false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG1PennLeakR",    false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG3PennLeakR",    false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG2ATMCalR",      false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG2HVacCalR",     false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG4ATMCalR",      false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG4HVacCalR",     false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG1GasCorrR",     false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG2GasCorrR",     false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG3GasCorrR",     false, dsDpParameters);
        // cpcExportGenericFunctions_processAddress(currentDP, sObject, "MG4GasCorrR",     false, dsDpParameters);

        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG1TFilt");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG2TFilt");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG3TFilt");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG4TFilt");

        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG1PrSour");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG3PrSour");

        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel1Scr");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel2Scr");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel3Scr");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel4Scr");
        
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG1PrH");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG3PrH");
        
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel1H");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel2H");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel3H");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel4H");

        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG1PrL");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DG3PrL");
        
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel1L");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel2L");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel3L");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel4L");
        
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DGPennLCo");

        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel1ToffMin");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel2ToffMin");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel3ToffMin");
        cpcExportGenericFunctions_getDefaultValue(currentDP, dsDpParameters, "DRel4ToffMin");
        

        dynAppend(dsDpParameters, cpcGenericDpFunctions_getMapping(currentDP, ".ProcessInput.ObjectSt"));
        dynAppend(dsDpParameters, cpcGenericDpFunctions_getMapping(currentDP, ".ProcessInput.CommSt"));
        dynAppend(dsDpParameters, cpcGenericDpFunctions_getMapping(currentDP, ".ProcessInput.Rel1St"));
        dynAppend(dsDpParameters, cpcGenericDpFunctions_getMapping(currentDP, ".ProcessInput.G1TFiltSt"));
        dynAppend(dsDpParameters, cpcGenericDpFunctions_getMapping(currentDP, ".ProcessInput.G1PrSourSt"));
        dynAppend(dsDpParameters, cpcGenericDpFunctions_getMapping(currentDP, ".ProcessInput.GPennLCoSt"));
        // dynAppend(dsDpParameters, cpcGenericDpFunctions_getMapping(currentDP, ".ProcessInput.AOTypeSt"));

        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.G1HWVarSt");
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.G2HWVarSt");
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.G3HWVarSt");
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.G4HWVarSt");
                
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_1, makeDynString(), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_2, makeDynString("ProcessInput.CommSt", "ProcessInput.HWConfigSt", "ProcessInput.FirmVersSt", "ProcessInput.Rel1St", "ProcessInput.Rel2St", "ProcessInput.Rel3St", "ProcessInput.Rel4St", "ProcessInput.PrG1St", "ProcessInput.PrG3St", "ProcessInput.G1TFiltSt", "ProcessInput.G2TFiltSt", "ProcessInput.G3TFiltSt", "ProcessInput.G4TFiltSt", "ProcessInput.G1PrSourSt", "ProcessInput.G3PrSourSt", "ProcessInput.G1HWVarSt", "ProcessInput.G2HWVarSt", "ProcessInput.G3HWVarSt", "ProcessInput.G4HWVarSt", "ProcessInput.AOTypeSt", "ProcessInput.Rel1ScrSt", "ProcessInput.Rel2ScrSt", "ProcessInput.Rel3ScrSt", "ProcessInput.Rel4ScrSt", "ProcessInput.G1PrHSt", "ProcessInput.G3PrHSt", "ProcessInput.Rel1HSt", "ProcessInput.Rel2HSt", "ProcessInput.Rel3HSt", "ProcessInput.Rel4HSt", "ProcessInput.G1PrLSt", "ProcessInput.G3PrLSt", "ProcessInput.Rel1LSt", "ProcessInput.Rel2LSt", "ProcessInput.Rel3LSt", "ProcessInput.Rel4LSt", "ProcessInput.GPennLCoSt", "ProcessInput.Rel1ToffMinSt", "ProcessInput.Rel2ToffMinSt", "ProcessInput.Rel3ToffMinSt", "ProcessInput.Rel4ToffMinSt" 
            //"ProcessInput.G1PennLeakSt", "ProcessInput.G3PennLeakSt", "ProcessInput.G2ATMCalSt", "ProcessInput.G2HVacCalSt", "ProcessInput.G4ATMCalSt", "ProcessInput.G4HVacCalSt", "ProcessInput.G1GasCorrSt", "ProcessInput.G2GasCorrSt", "ProcessInput.G3GasCorrSt", "ProcessInput.G4GasCorrSt"
            ), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_3, makeDynString("ProcessInput.evStsReg01"), dsDpParameters);

        cpcExportGenericFunctions_getMaskEvent(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getParameters(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getMetainfo(currentDP, dsDpParameters, exceptionInfo);
//end_TAG_SCRIPT_DEVICE_TYPE_export

        unExportDevice_writeDsStringToFile(dsDpParameters, UN_PARAMETER_DELIMITER);
    }
}

/**
Purpose: Export CPC_VR_GT Devices for S7_PLC front-end

Usage: External function

PVSS manager usage: NG, NV
*/
S7_PLC_CPC_VR_GT_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    CPC_VR_GTConfig_ExportConfig(dsDpList, exceptionInfo);
}

/**
Purpose: Export CPC_VR_GT Devices for _UnPlc front-end

Usage: External function

PVSS manager usage: NG, NV
*/
_UnPlc_CPC_VR_GT_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    CPC_VR_GTConfig_ExportConfig(dsDpList, exceptionInfo);
}

OPCUA_CPC_VR_GT_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    CPC_VR_GTConfig_ExportConfig(dsDpList, exceptionInfo);
}

BACnet_CPC_VR_GT_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    CPC_VR_GTConfig_ExportConfig(dsDpList, exceptionInfo);
}

//@}
