/**@name LIBRARY: vacuum_declarations.ctl

@author: Sebastien Blanchard
@author: Marcin Bes
@author: Thijs van Winden

version 1.2

External Functions: None

Internal Functions: None

Purpose: This library contains Vacuum Unicos constants.

Usage: Public

Constraints:
	. PVSS version: 3.11 and higher 
*/

// List all the components in the vacuum package
const string UNVACSTATEHISTORY_COMPONENT = "unVacuum";
const string UNVACTRENDING_COMPONENT = "unVacuum";
    

// unVacuum menu items
const int CPC_POPUPMENU_NAME  = 701;
const int CPC_POPUPMENU_POSST  = 702;  
const int CPC_POPUPMENU_DISABLE = 703;  
const int CPC_POPUPMENU_STARTORDER = 704;
const int CPC_POPUPMENU_STOPORDER = 705;
const int CPC_POPUPMENU_ALIAS = 706;
const int CPC_POPUPMENU_HELP = 707;
const int CPC_POPUPMENU_CONTROLLER = 708;
const int CPC_POPUPMENU_WORKORDER = 709;
const int CPC_POPUPMENU_INFORDB = 710;
const int CPC_POPUPMENU_VACDB = 711;
const int CPC_POPUPMENU_STATEHISTORY = 712;
const int CPC_POPUPMENU_TRENDHISTORY = 713;

//unVacuum constants
const string CPC_PROP_NAME_MACHINE_TYPE = "MACHINE_TYPE";
const string CPC_PROP_NAME_HELP = "HELP";
const string CPC_VAC_MACHINE_TYPE_LHC = "LHC";
const string CPC_VAC_MACHINE_TYPE_SPS = "SPS";
const string CPC_VAC_MACHINE_TYPE_CPS = "cPS";
const string CPC_VAC_ANALOG_FORMAT = "%.1e";

// VG_PT registers
const unsigned CPC_StsReg01_SWOFFOV 	= 0;
const unsigned CPC_StsReg01_SWONOV 		= 1;
const unsigned CPC_StsReg01_AUTOOV 		= 5;
const unsigned CPC_StsReg02_AUONPRST 	= 1;
const unsigned CPC_StsReg02_MONPRST 	= 2;
const unsigned CPC_StsReg02_AUOFFPRST = 3;
const unsigned CPC_StsReg02_MOFFPRST 	= 4;
const unsigned CPC_StsReg02_AUONFRST 	= 5;
const unsigned CPC_StsReg02_AUSBPRST 	= 5;
const unsigned CPC_StsReg02_MONFRST 	= 6;
const unsigned CPC_StsReg02_MSBPRST 	= 6;
const unsigned CPC_StsReg02_AUMRW     = 7;
const unsigned CPC_StsReg02_AURSTPRST	= 7;
const unsigned CPC_StsReg02_MRSTPRST  = 8;
const unsigned CPC_StsReg02_OUTRSTOVST=12; 
//const unsigned CPC_StsReg02_OUTOFFOVST=14; already defined
const unsigned CPC_StsReg02_OUTSBOVST =15;

const unsigned CPC_ManReg01_MONF = 11;

// VG_PT buttons
const string UN_FACEPLATE_BUTTON_ONFORCED_REQUEST = "OnForced";

// VG_PT parameters
const string CPC_PARAMS_URVALID 		= "URValid";
const string CPC_PARAMS_HALFFULLLIMIT 	= "HalfFullLimit";

// VP_TP registers
const unsigned CPC_StsReg01_IOWARNINGW = 5;
const unsigned CPC_ManReg01_RESETERRWARN = 12;

// VP_TP buttons
const string UN_FACEPLATE_BUTTON_RESETERRWARN_REQUEST = "ResetErrWarn"; //for VP_TP

// VP_TP parameteres
const string CPC_PROP_NAME_INTERFACE_TYPE = "INTERFACE_TYPE";
const string CPC_PROP_NAME_CONTROLLER_MODEL = "CONTROLLER_MODEL";
const string CPC_PROP_NAME_INSTRUMENT_MODEL = "INSTRUMENT_MODEL";

// VR_GT registers
const unsigned CPC_ManReg01_WRITEOVST 		= 0;
const unsigned CPC_ManReg01_READOVST 		= 1;

const unsigned CPC_ManReg01_MG1TFILTR 		= 0;
const unsigned CPC_ManReg01_MG2TFILTR 		= 1;
const unsigned CPC_ManReg01_MG3TFILTR 		= 2;
const unsigned CPC_ManReg01_MG4TFILTR 		= 3;
const unsigned CPC_ManReg01_MG1PRSOURR 		= 4;
const unsigned CPC_ManReg01_MG3PRSOURR 		= 5;
const unsigned CPC_ManReg01_MREL1SCRR 		= 6;
const unsigned CPC_ManReg01_MREL2SCRR 		= 7;
const unsigned CPC_ManReg01_MREL3SCRR 		= 8;
const unsigned CPC_ManReg01_MREL4SCRR 		= 9;
const unsigned CPC_ManReg01_MG1PRHR 		= 10;
const unsigned CPC_ManReg01_MG3PRHR 		= 11;
const unsigned CPC_ManReg01_MREL1HR 		= 12;
const unsigned CPC_ManReg01_MREL2HR 		= 13;
const unsigned CPC_ManReg01_MREL3HR 		= 14;
const unsigned CPC_ManReg01_MREL4HR 		= 15;

const unsigned CPC_ManReg02_MG1PRLR 		= 0;
const unsigned CPC_ManReg02_MG3PRLR 		= 1;
const unsigned CPC_ManReg02_MREL1LR 		= 2;
const unsigned CPC_ManReg02_MREL2LR 		= 3;
const unsigned CPC_ManReg02_MREL3LR 		= 4;
const unsigned CPC_ManReg02_MREL4LR 		= 5;
const unsigned CPC_ManReg02_MGPENNLCOR 		= 6;
const unsigned CPC_ManReg02_MREL1TOFFMINR	= 8;
const unsigned CPC_ManReg02_MREL2TOFFMINR 	= 9;
const unsigned CPC_ManReg02_MREL3TOFFMINR 	= 10;
const unsigned CPC_ManReg02_MREL4TOFFMINR 	= 11;
const unsigned CPC_ManReg02_MG1PENNLEAKR 	= 14;
const unsigned CPC_ManReg02_MG3PENNLEAKR 	= 15;

const unsigned CPC_ManReg03_MG2ATMCALR 		= 0;
const unsigned CPC_ManReg03_MG2HVACCALR 	= 1;
const unsigned CPC_ManReg03_MG4ATMCALR 		= 2;
const unsigned CPC_ManReg03_MG4HVACCALR 	= 3;
const unsigned CPC_ManReg03_MG1GASCORRR 	= 4;
const unsigned CPC_ManReg03_MG2GASCORRR 	= 5;
const unsigned CPC_ManReg03_MG3GASCORRR 	= 6;
const unsigned CPC_ManReg03_MG4GASCORRR 	= 7;

const unsigned CPC_ManReg03_MWRITEALLR 		= 8;
const unsigned CPC_ManReg03_MREADALLR 		= 9;

// VR_GT buttons
const string UN_FACEPLATE_BUTTON_REFRESH 		= "Refresh";
const string UN_FACEPLATE_BUTTON_RESTORE_ALL_AND_WRITE = "RestoreAllAndWrite";
const string UN_FACEPLATE_BUTTON_ONLINE_VALUES 	= "OnlineValues";

// VR_GT parameters
const string CPC_PARAMS_GAUGE1_NAME = "G1";
const string CPC_PARAMS_GAUGE2_NAME = "G2";
const string CPC_PARAMS_GAUGE3_NAME = "G3";
const string CPC_PARAMS_GAUGE4_NAME = "G4";
const string CPC_PARAMS_RELAY1_NAME = "R1";
const string CPC_PARAMS_RELAY2_NAME = "R2";
const string CPC_PARAMS_RELAY3_NAME = "R3";
const string CPC_PARAMS_RELAY4_NAME = "R4";

// VP_I registers
const unsigned CPC_StsReg01_KV3RST = 5; 
//const unsigned CPC_StsReg02_OUTONOVST = 0; Already defined
const unsigned CPC_StsReg02_AUSTPMRST = 7;
const unsigned CPC_StsReg02_MSTPMRST = 8;
const unsigned CPC_StsReg02_AUFIXMRST = 9;
const unsigned CPC_StsReg02_KV5RST = 12;
const unsigned CPC_StsReg02_MFIXMRST = 14;
const unsigned CPC_StsReg02_KV7RST = 15;

const unsigned CPC_ManReg01_MSTPMR = 7;
const unsigned CPC_ManReg01_MFIXMR = 8;
const unsigned CPC_ManReg01_M3KVR = 12;
const unsigned CPC_ManReg01_M5KVR = 13;
const unsigned CPC_ManReg01_M7KVR = 14;

// VP_I buttons
const string UN_FACEPLATE_BUTTON_OPERATION_MODES = "OperationModes"; //for VP_TP

// VP_I parameters
const string CPC_VP_I_MODE_FIXED = "fixed";
const string CPC_VP_I_MODE_STEP = "step";
const string CPC_VP_I_MODE_FIXED_3KV = "3kv";
const string CPC_VP_I_MODE_FIXED_5KV = "5kv";
const string CPC_VP_I_MODE_FIXED_7KV = "7kv";

// VV_S registers
const unsigned CPC_StsReg03_LCL1ITLST = 0;
const unsigned CPC_StsReg03_OPEN1ST = 1;
const unsigned CPC_StsReg03_TEMPITLST = 2;
const unsigned CPC_StsReg03_LCL2ITLST = 2;
const unsigned CPC_StsReg03_GLBBEFOREITLST = 3;
const unsigned CPC_StsReg03_GLBAFTERITLST = 4;
const unsigned CPC_StsReg03_PRITLENST = 5;
const unsigned CPC_StsReg03_OPEN2ST = 5;
const unsigned CPC_StsReg03_VVSCONST = 6;
const unsigned CPC_StsReg03_BDRST = 7;
const unsigned CPC_StsReg03_CLENST = 8;
const unsigned CPC_StsReg03_REMCTRENST = 9;
const unsigned CPC_StsReg03_PREVCLST = 10;


// VV_S parameters

//VV_S buttons

// VV_S alarms
const string CPC_WIDGET_TEXT_ALARM_LOCAL_INT = "LI";
const string CPC_WIDGET_TEXT_ALARM_PROPAGATED_INT = "PI";
const string CPC_WIDGET_TEXT_ALARM_OPEN_DISABLE = "OD";
const string CPC_WIDGET_TEXT_ALARM_PREVENTIVE_CLOSE = "PC";

// VV_S controls
const string CPC_WIDGET_TEXT_CONTROL_LOCAL = "L";
const string CPC_WIDGET_TEXT_CONTROL_CLOSE_ENABLE = "CE";

// VV_S warnings
const string CPC_WIDGET_TEXT_WARNING_LOCAL = "L";
const string CPC_WIDGET_TEXT_WARNING_CLOSE_ENABLE = "CE";

// VR_AH parameters
const string CPC_PROP_NAME_SOURCE1 = "S1";
const string CPC_PROP_NAME_SOURCE2 = "S2";
const string CPC_PROP_NAME_CONTROLLER = "CONTROLLER";
const string CPC_PROP_NAME_INSTRUMENT = "INSTRUMENT";
const string CPC_PROP_NAME_CHANNELS = "CHANNELS";
const string CPC_PROP_NAME_CONFIG_TYPE = "CONFIG_TYPE";

// VR_AH registers

// Vacuum general declarations
const dyn_string  CPC_BODY_COLORS = makeDynString(
    "unDataNotValid",               // Invalid color
    "unWidget_AlarmNotAck",         // Alarm Unacknowledged color
    "unFaceplate_AlarmActive",      // Alarm active color
    "FwEquipmentDisabled",          // Device disabled color
    "cpcColor_Widget_Warning",      // Warning color
    "unWidget_ControlStateForced",  // Forced mode color
    "unWidget_ControlStateForced",  // Undefined color
    "unEventList_ForeColor",        // Off color (optional color)
    "cpcColor_Widget_Request",      // Under Range color
    "cpcColor_Widget_Status"        // OK color
);

// Default vacuum warning bits
const dyn_string VAC_WARNING_BITS = makeDynString(
    "CPC_StsReg01_IOSIMUW", // I/O are simulated
    "CPC_StsReg01_IOERRORW", // Error from Hardware
    "",
    "",
    ""
);   

// Default CPC warning bits
const dyn_string CPC_WARNING_BITS = makeDynString(
    "CPC_StsReg01_IOSIMUW", // I/O are simulated
    "CPC_StsReg01_IOERRORW", // Error from Hardware
    "CPC_StsReg01_MIOERBRST",  // Manual IOError Block Request Status
    "CPC_StsReg02_ALBW", // Alarm has been blocked (by operator) 
    ""
); 

// Default warning letters
const dyn_string CPC_WARNING_LETTERS = makeDynString(
    CPC_WIDGET_TEXT_WARNING_SIMU, 
    CPC_WIDGET_TEXT_WARNING_ERROR, 
    CPC_WIDGET_TEXT_WARNING_ALARM_BLOCKED,
    CPC_WIDGET_TEXT_WARNING_ALARM_BLOCKED,
    CPC_WIDGET_TEXT_WARNING_DEFAULT
);


// Default VAC alarm letters
const dyn_string VAC_ALARM_BITS = makeDynString("", "", "", "", "");
   
// Default CPC alarm bits
const dyn_string CPC_ALARM_BITS = makeDynString( // Bitnames
    "CPC_StsReg01_ALST",       // Alarm status
    "CPC_StsReg01_STARTIST",   // Start interlock
    "CPC_StsReg01_TSTOPIST",   // Temporary stop interlock
    "CPC_StsReg02_FUSTOPIST",  // Full stop interlock
    ""                         // Object requires manual restart
);               
// Default CPC alarm letters
const dyn_string CPC_ALARM_LETTERS = makeDynString( // Letters for corresponding bitnames
    CPC_WIDGET_TEXT_ALARM_ALST, 
    CPC_WIDGET_TEXT_ALARM_STARTIST, 
    CPC_WIDGET_TEXT_ALARM_TSTOPIST,
    CPC_WIDGET_TEXT_ALARM_FUSTOPIST,
    CPC_WIDGET_TEXT_MANUAL_RESTART
); 

// Default VAC control bits
const dyn_string VAC_CONTROL_BITS = makeDynString("", "", "CPC_StsReg01_MaMoSt", "");
// Default CPC control bits
const dyn_string CPC_CONTROL_BITS = makeDynString( // Bitnames                    
    "CPC_StsReg01_FoMoSt",
    "CPC_StsReg01_AUIHFOMOST",
    "CPC_StsReg01_MaMoSt", 
    "CPC_StsReg01_AUIHMBST"
);    
// Default vacuum control letters
const dyn_string CPC_CONTROL_LETTERS  = makeDynString(
    CPC_WIDGET_TEXT_CONTROL_FORCED, 
    CPC_WIDGET_TEXT_CONTROL_AUIHFOMOST, 
    CPC_WIDGET_TEXT_CONTROL_MANUAL,
    CPC_WIDGET_TEXT_CONTROL_AUINHMMO  
); 


// The default state message
const string CPC_STATE_INVALID = "Invalid";
const string CPC_STATE_ALARMUNACK = "Alarm";
const string CPC_STATE_ALARM = "Interlock";
const string CPC_STATE_DISABLED = "Disabled";
const string CPC_STATE_WARNING = "Warning";
const string CPC_STATE_FORCED = "Forced";
const string CPC_STATE_UNDEFINED = "Undefined";
const string CPC_STATE_UNDERRANGE = "Under Range";
const string CPC_STATE_OFF = "Off/Closed";
const string CPC_STATE_ON = "On/Open";

// Default cpc state history names
const dyn_string CPC_STATE_NAMES = makeDynString(
    CPC_STATE_INVALID,
    CPC_STATE_ALARMUNACK,
    CPC_STATE_ALARM,
    CPC_STATE_DISABLED,
    CPC_STATE_WARNING,
    CPC_STATE_FORCED,
    CPC_STATE_UNDEFINED,
    CPC_STATE_UNDERRANGE,
    CPC_STATE_OFF
);


// VR_PI manual registers
const int CPC_ManReg02_MREADALLR = 8;

// VR_PI params
const string CPC_PARAMS_PUMP1_NAME = "P1";
const string CPC_PARAMS_PUMP2_NAME = "P2";
const string CPC_PARAMS_PUMP3_NAME = "P3";
const string CPC_PARAMS_PUMP4_NAME = "P4";

// VR_PI communication params
const int CPC_VR_PI_PARAM_HCONFS1ST    = 1;
const int CPC_VR_PI_PARAM_HCONFS2ST    = 2;
const int CPC_VR_PI_PARAM_FIRMVERST	   = 3;
const int CPC_VR_PI_PARAM_FANTEMPST	   = 4;
const int CPC_VR_PI_PARAM_CH1TEMPST	   = 5;
const int CPC_VR_PI_PARAM_CH2TEMPST	   = 6;
const int CPC_VR_PI_PARAM_CH3TEMPST    = 7;
const int CPC_VR_PI_PARAM_CH4TEMPST	   = 8;
const int CPC_VR_PI_PARAM_RESTARTMOST  = 9;
const int CPC_VR_PI_PARAM_CTRLMOST     = 10;
const int CPC_VR_PI_PARAM_PRUNITST     = 11;
const int CPC_VR_PI_PARAM_CH1PROTST	   = 12;
const int CPC_VR_PI_PARAM_CH2PROTST	   = 13;
const int CPC_VR_PI_PARAM_CH3PROTST	   = 14;
const int CPC_VR_PI_PARAM_CH4PROTST	   = 15;
const int CPC_VR_PI_PARAM_CH1PR100NAST = 16;
const int CPC_VR_PI_PARAM_CH1PR10UAST  = 17;
const int CPC_VR_PI_PARAM_CH1PR10MAST  = 18;
const int CPC_VR_PI_PARAM_CH1PR400MAST = 19;
const int CPC_VR_PI_PARAM_CH2PR100NAST = 20;
const int CPC_VR_PI_PARAM_CH2PR10UAST  = 21;
const int CPC_VR_PI_PARAM_CH2PR10MAST  = 22;
const int CPC_VR_PI_PARAM_CH2PR400MAST = 23;
const int CPC_VR_PI_PARAM_CH3PR100NAST = 24;
const int CPC_VR_PI_PARAM_CH3PR10UAST  = 25;
const int CPC_VR_PI_PARAM_CH3PR10MAST  = 26;
const int CPC_VR_PI_PARAM_CH3PR400MAST = 27;
const int CPC_VR_PI_PARAM_CH4PR100NAST = 28;
const int CPC_VR_PI_PARAM_CH4PR10UAST  = 29;
const int CPC_VR_PI_PARAM_CH4PR10MAST  = 30;
const int CPC_VR_PI_PARAM_CH4PR400MAST = 31;

// VP_G params
const string CPC_PARAMS_PCO_NAME = "PCO_NAME";
const string CPC_PARAMS_VPP  = "VPP";
const string CPC_PARAMS_VPT  = "VPT";
const string CPC_PARAMS_VVI  = "VVI";
const string CPC_PARAMS_VVD  = "VVD";
const string CPC_PARAMS_VVT  = "VVT";
const string CPC_PARAMS_VVP  = "VVP";
const string CPC_PARAMS_VGF  = "VGF";
const string CPC_PARAMS_VVR1 = "VVR1";
const string CPC_PARAMS_VVR2 = "VVR2";
const string CPC_PARAMS_VVR3 = "VVR3";

// VG_F registers
const unsigned CPC_StsReg02_PEGDST = 15;
